;
; ---------------------------------------------------
; THE updated 'E-FORMAT TO FLOATING POINT' SUBROUTINE
; ---------------------------------------------------
; (Offset $38: 'e-to-fp')
; invoked from DEC-TO-FP and PRINT-FP.
; e.g. 2.3E4 is 23000.
; This subroutine evaluates xEm where m is a positive or negative integer.
;
; The updated version based on the Speccy's solution (but 6 bytes shorter).
;
; On entry in the ZX81, m, the exponent, is the 'last value', and the
; floating-point decimal mantissa is beneath it.
;
;; e-to-fp
;; E-TO-FP
L155A:
	call L158A		; routine FP-TO-BC (m)

	jr z,M_POSTV		;
	inc b			; if negative then B=1
M_POSTV
	and a			; test if zero
	ret z			; and return

	push bc			; save exponent

	rst 28H		;; FP-CALC	x.
	.db $A4		;;stk-ten	x, 10.
        .db $34		;;end-calc
;
;; E-LOOP	now enter a loop
E_LOOP:
	pop bc			; restore exponent

	srl c			; 0>76543210>C
	push bc			; save shifted exponent.
	jr nc,E_TST_E1		; forward to E-TST-END if no bit

	push af			; save flags.
	djnz E_MULT		

	rst 28H		;; FP-CALC
	.db $C2		;;st-mem-2	x, 10.
	.db $05		;;division	x/10.
	.db $E2		;;get-mem-2	x/10, 10.
        .db $34		;;end-calc	new x, 10.

	jr E_TST_E0		; forward to E-TST-END
E_MULT:
	rst 28H		;; FP-CALC
	.db $C2		;;st-mem-2	x, 10.
	.db $04		;;multiply	x*10.
	.db $E2		;;get-mem-2	x*10, 10.
        .db $34		;;end-calc	new x, 10.
; 
;; E-TST-END	the loop branched to here with no carry
E_TST_E0
	pop af			; restore flags
E_TST_E1:
	jr z,E_END		; forward to E-END  if A emptied of bits

	rst 28H		;; FP-CALC
	.db $2D		;;duplicate	new x, 10, 10.
	.db $04		;;multiply	new x, 100.
	.db $34		;;end-calc

	jr E_LOOP		; back to E-LOOP  until all bits done.
; ---
; although only the first pass is shown it can be seen that for each set bit
; representing a power of two, x is multiplied or divided by the corresponding
; power of ten.

;; E-END
E_END:
	pop bc			; clear stack

	rst 28H		;; FP-CALC	final x, factor.
	.db $02		;;delete	final x.
	.db $34		;;end-calc	x.

	ret			; return
; ---
	.db $FF			; spare
